Lattice Grid Buy a licence

demo D46

The formatting panel

A user building their own rules at runtime, undoable and saved

grid.formatting.add()

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // Two seeded rules, so the list is not empty on arrival and a rule from
  // configuration reads as the same thing as a rule added in the panel. The
  // first is grid-wide, keyed on '*', the scope the panel opens on; add a rule
  // there and it is undoable and rides along in a saved view.
  const formatting = {
    '*': [
      { id: 'any-failing', when: { op: 'eq', value: 'failing' }, style: { background: '#fbeceb', color: '#b03030' } },
    ],
    openIncidents: [
      { id: 'incidents-open', when: { op: 'gte', value: 5 }, style: { background: '#fbeceb', color: '#b03030', fontWeight: '600' } },
    ],
  };

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'state', title: 'State', filter: { type: 'set' } },
    { field: 'instances', title: 'Instances', type: 'number' },
    { field: 'openIncidents', title: 'Incidents', type: 'number' },
    { field: 'p99Ms', title: 'p99 ms', type: 'number' },
    { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
  ];

  const rows = [/* 5,000 service records */];

  function App() {
    // The Formatting tab is a built-in panel, opened on arrival because it is the
    // subject: adding or removing a rule is one call the grid records, so it is
    // undoable and lands in a view.
    return (
      <LatticeGrid
        rowKey="id"
        formatting={formatting}
        toolPanel={{ side: 'left', panels: ['formatting', 'columns', 'filters', 'views'], openPanel: 'formatting',
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' }}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Letting users build their own conditional formatting at runtime

Conditional formatting is usually fixed at build time, but some tools need the end user to define their own highlight rules while the grid is live, an operations dashboard where an analyst wants “flag anything over 500ms in red” without filing a ticket. Lattice Grid supports this through grid.formatting.add(), an imperative method that appends a rule to a column’s formatting list after the grid has already rendered, alongside a matching remove call so a rule panel can list, edit, and retract entries. Each rule takes the same { when, style } shape as configuration-driven rules, so a UI built on top of this API is a form that serialises a condition and a style into one call. Because rule creation sits outside the render path, this pairs with an undo stack: capturing the rule set before and after each add or remove gives undo and redo with no bespoke diffing, and the same serialised list can be persisted to storage and reapplied on load.

Rules added at runtime are compiled into the same per-column lookup used by static formatting, so a JavaScript data grid with a hundred user-authored rules scrolls at the same cost as one configured entirely up front: evaluation stays a fixed per-cell operation during rendering rather than a growing chain of conditions checked in sequence.

How do I let users create their own cell formatting rules?

Call grid.formatting.add() to insert a rule at runtime, and its matching remove method to take one out. Each rule is the same { when, style } pair used in static configuration, so a small form (condition plus colour) is enough to build an editable rules panel, and keeping a list of applied rules gives undo and redo for free.

Lattice Grid Buy a licence

demo D46

The formatting panel

A user building their own rules at runtime, undoable and saved

grid.formatting.add()

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// Two seeded rules, so the list is not empty on arrival and a rule from
// configuration reads as the same thing as a rule added in the panel. The
// first is grid-wide, keyed on '*', the scope the panel opens on; add a rule
// there and it is undoable and rides along in a saved view.
const formatting = {
  '*': [
    { id: 'any-failing', when: { op: 'eq', value: 'failing' }, style: { background: '#fbeceb', color: '#b03030' } },
  ],
  openIncidents: [
    { id: 'incidents-open', when: { op: 'gte', value: 5 }, style: { background: '#fbeceb', color: '#b03030', fontWeight: '600' } },
  ],
};

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'state', title: 'State', filter: { type: 'set' } },
  { field: 'instances', title: 'Instances', type: 'number' },
  { field: 'openIncidents', title: 'Incidents', type: 'number' },
  { field: 'p99Ms', title: 'p99 ms', type: 'number' },
  { field: 'monthlyCost', title: 'Monthly cost', type: 'number', format: { style: 'currency', currency: 'USD' } },
];

const rows = [/* 5,000 service records */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    formatting: formatting,
    toolPanel: { side: 'left', panels: ['formatting', 'columns', 'filters', 'views'], openPanel: 'formatting',
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' },
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Letting users build their own conditional formatting at runtime

Conditional formatting is usually fixed at build time, but some tools need the end user to define their own highlight rules while the grid is live, an operations dashboard where an analyst wants “flag anything over 500ms in red” without filing a ticket. Lattice Grid supports this through grid.formatting.add(), an imperative method that appends a rule to a column’s formatting list after the grid has already rendered, alongside a matching remove call so a rule panel can list, edit, and retract entries. Each rule takes the same { when, style } shape as configuration-driven rules, so a UI built on top of this API is a form that serialises a condition and a style into one call. Because rule creation sits outside the render path, this pairs with an undo stack: capturing the rule set before and after each add or remove gives undo and redo with no bespoke diffing, and the same serialised list can be persisted to storage and reapplied on load.

Rules added at runtime are compiled into the same per-column lookup used by static formatting, so a JavaScript data grid with a hundred user-authored rules scrolls at the same cost as one configured entirely up front: evaluation stays a fixed per-cell operation during rendering rather than a growing chain of conditions checked in sequence.

How do I let users create their own cell formatting rules?

Call grid.formatting.add() to insert a rule at runtime, and its matching remove method to take one out. Each rule is the same { when, style } pair used in static configuration, so a small form (condition plus colour) is enough to build an editable rules panel, and keeping a list of applied rules gives undo and redo for free.